{*******************************************************}
{                                                       }
{       UsrAutoLink                                     }
{                                                       }
{       Ȩ (C) 2014 ޹˾    }
{                                                       }
{*******************************************************}

unit Unitzzming;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, IdBaseComponent, IdComponent, IdUDPBase, IdUDPServer, IdSocketHandle,
  ExtCtrls, IdGlobal, ComCtrls;

type
  PByte = ^Byte;
  PChar = ^Char;

  TForm2 = class(TForm)
    edtKey: TEdit;
    btnSearch: TButton;
    idpsrvr1: TIdUDPServer;
    lvSsid: TListView;
    edt_SearchPort: TEdit;
    lbl_SearchPort: TLabel;
    Key: TLabel;
    procedure btnSearchClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure edtKeyEnter(Sender: TObject);
    procedure edtKeyExit(Sender: TObject);
    procedure edtKeyKeyPress(Sender: TObject; var Key: Char);
    procedure idpsrvr1UDPRead(AThread: TIdUDPListenerThread;
      AData: TIdBytes; ABinding: TIdSocketHandle);
    procedure lvSsidDblClick(Sender: TObject);
    procedure edt_SearchPortKeyPress(Sender: TObject; var Key: Char);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;
  BufSsids: array of TIdBytes;
  BufS: TIdBytes;
  BufSsid: TIdBytes;
  LSsid: Integer;
  LKey: Integer;
  SearchPort: Integer; //˿

{----------˿ Ҫע---------

48899˿ڣC32xϵеĶ˿ڣûATָ
49000˿ڣC32xϵУWIFIģĶ˿
1902˿ڣƿرϵвƷĶ˿

----------˿ Ҫע---------}

implementation

{$R *.dfm}

//==========УԶȡSSID======
procedure TForm2.FormCreate(Sender: TObject);
var
  BufSearch: TIdBytes;
begin
  SearchPort := StrToInt(edt_SearchPort.Text);
  SetLength(BufSearch, 5);
  BufSearch[0] := $FF;
  BufSearch[1] := $00;
  BufSearch[2] := $01;
  BufSearch[3] := $01;
  BufSearch[4] := $02;
  idpsrvr1.SendBuffer('255.255.255.255', SearchPort, BufSearch);
end;

//===========ťȡSSID==============
procedure TForm2.btnSearchClick(Sender: TObject);
var
  BufSearch: TIdBytes;
begin
  SearchPort := StrToInt(edt_SearchPort.Text);
  SetLength(BufSearch, 5);
  BufSearch[0] := $FF;
  BufSearch[1] := $00;
  BufSearch[2] := $01;
  BufSearch[3] := $01;
  BufSearch[4] := $02;
  idpsrvr1.SendBuffer('255.255.255.255', SearchPort, BufSearch);
end;

//++++++++++++ۼӼУ++++++++++
function SUMChk(aPBuf: PByteArray; aCount: Integer): Byte;
var
  i: Integer;
begin
  Result := 0;
  for i := 0 to aCount - 1 do
    if Result + aPBuf[i] >= 256 then
      Result := Result + aPBuf[i] - 256
    else
      Result := Result + aPBuf[i];
end;

//++++++++++++Buf To ASCת++++++++++
function BufToASC(Buf: TIdBytes): string;
var
  n: Integer;
begin
  Result := '';
  for n := 0 to Length(Buf) - 1 do
  begin
    Result := Result + Char(Buf[n]);
  end;
end;

//================մ======================
procedure TForm2.idpsrvr1UDPRead(AThread: TIdUDPListenerThread;
  AData: TIdBytes; ABinding: TIdSocketHandle);
var
  i, j, a: Integer;
begin
  try
    if (Length(AData) <= 6)
      or (AData[0] <> $FF)
      or (SUMChk(@AData[1], Length(AData) - 2) <> AData[Length(AData) - 1])
    then
      exit;
    case AData[3] of
      $81:
        begin
          lvSsid.Clear;
          SetLength(BufSsids, AData[4] + 1);
          j := 3;
          a := 0;
          for i := Low(AData) to High(AData) do
          begin
            if (AData[i - 1] = $0D) and (AData[i] = $0A) then
            begin
              SetLength(BufSsids[a], i - j - 5);
              CopyMemory(@BufSsids[a][0], @AData[j + 2], i - j - 5);
              with lvSsid.Items.Add do
              begin
                Caption := BufToASC(BufSsids[a]);
                SubItems.Add(IntToStr(AData[i - 2]) + '%');
              end;
              Inc(a);
              j := i - 1;
            end;
          end;
        end;
      $82:
        begin
          if AData[5] = $01 then
          begin
            if AData[4] = $01 then
            begin
              ShowMessage('ύɹ豸״̬');
            end
            else
              ShowMessage('SSIDˣػSSID');
          end
          else
            ShowMessage('ʽ');
        end;
    end;
  except
    exit;
  end;
end;

//===========봦=============
procedure TForm2.edtKeyEnter(Sender: TObject);
begin
  edtKey.Color := $00EAF3DA;
  if edtKey.Text = '' then
    edtKey.Text := '';
end;

procedure TForm2.edtKeyKeyPress(Sender: TObject; var Key: Char);
begin
  if Key >= #160 then Key := #0;
end;

procedure TForm2.edtKeyExit(Sender: TObject);
begin
  edtKey.Color := clWindow;
end;

//==========˫SSIDύSSIDKEY============
procedure TForm2.lvSsidDblClick(Sender: TObject);
begin
  if lvSsid.Items.Count = 0 then
    exit;
  {------SSID------}
  LSsid := Length(BufSsids[lvSsid.ItemIndex]);
  SetLength(BufSsid, LSsid);
  CopyMemory(@BufSsid[0], @BufSsids[lvSsid.ItemIndex][0], LSsid);

  {------KEY------}
  if edtKey.Text = '' then
  begin
    edtKey.Color := clRed;
    edtKey.Text := '';
  end
  else
  begin
    LKey := Length(edtKey.Text);
  end;

  {------SEND------}
  if (edtKey.Text <> '') and (edtKey.Text <> '') then
  begin
    SetLength(BufS, LSsid + LKey + 8);
    BufS[0] := $FF;
    BufS[1] := $00;
    BufS[2] := LSsid + LKey + 4;
    BufS[3] := $02;
    BufS[4] := $00;
    CopyMemory(@BufS[5], @BufSsid[0], LSsid);
    BufS[5 + LSsid] := $0D;
    BufS[6 + LSsid] := $0A;
    CopyMemory(@BufS[7 + LSsid], @edtKey.Text[1], LKey);
    BufS[7 + LSsid + LKey] := SUMChk(@BufS[1], LSsid + LKey + 6);
    idpsrvr1.SendBuffer('255.255.255.255', SearchPort, BufS);
  end;
end;
procedure TForm2.edt_SearchPortKeyPress(Sender: TObject; var Key: Char);
begin
  if not (Key in ['0'..'9', #8]) then //#8 ˸
  begin
    Key := #0;
    MessageBeep(1); //Beep;
  end;
end;

end.

